MantisBT

View Issue Details Jump to Notes ] Issue History ] Print ]
IDProjectCategoryView StatusDate SubmittedLast Update
0001897VCMIAI - Adventure Mappublic2014-09-23 17:192017-03-19 02:25
ReporterPovelitel 
Assigned ToSXX 
PrioritynormalSeverityblockReproducibilityalways
StatusresolvedResolutionfixed 
PlatformOSWin XP sp2OS Version
Product Version0.96 
Target VersionFixed in Version0.next 
Summary0001897: Game hangs after AI captures town from player in battle
Descriptionprobably occurred due to the fact that I fought back from a random city

it was http://youtu.be/_fkdQH86eBc [^]

Summary edited, was "After the battle, the game is blocked"
Steps To Reproduceend turn, AI atack on castle kill my unit and game freeze
конец хода, ИИ нападает на город, убивает моего юнита сидящего в нем и игра фризится.
TagsNo tags attached.
Attached Files? file icon Arrogance5.h3m [^] (12,197 bytes) 2014-09-23 17:19
txt file icon VCMI_Client_log.txt [^] (676,338 bytes) 2014-09-23 17:19 [Show Content]
txt file icon VCMI_Server_log.txt [^] (442,749 bytes) 2014-09-23 17:20 [Show Content]

- Relationships
has duplicate 0001948resolvedSXX [Android][Freeze] Finishing an attacking AI battle will freeze the game 
has duplicate 0002045closed Wyłącza się jak Ktoś atakuje mi miasto 
has duplicate 0002163resolvedSXX Multiplayer: freeze if 1st player end turn after PVP battle before 2nd player closed battle result screen 
related to 0001724new I loose game, but crash, 
related to 0002122assignedWarmonger When ai take my town - crash 
related to 0002141resolvedSXX end turn battle 
related to 0002597resolvedSXX Freeze after battle 

-  Notes
(0005133)
Povelitel (updater)
2014-11-20 12:22
edited on: 2014-11-20 12:22

Now (0.97), this is hero just not attacks :D

(0006888)
Povelitel (updater)
2016-11-03 08:47

0.99 still reproducibility
(0006962)
val-gaav (reporter)
2017-01-28 21:21

I can confirm this bug with 0.99

If you change to quick combat before ending turn the AI will take castle and the game will not freeze. So at least there is a way to continue game.
(0006965)
Dydzio (developer)
2017-02-01 15:08

I also noticed that you can press alt + f4 and then press cancel to "unfreeze".
(0006988)
Dydzio (developer)
2017-03-18 18:37

Result of little research: CPlayerInterface::playerStartsTurn gets called during battle result screen, and following code from that method brutally deletes result window:

while (GH.listInt.front() != adventureInt && !dynamic_cast<CInfoWindow*>(GH.listInt.front()))
GH.popInts(1);

After adding "&& !dynamic_cast<CBattleResultWindow*>(GH.listInt.front())" to above "while" loop and properly closing battle result window deadlock is solved. This is most likely not proper fix and it looks like CPlayerInterface::playerStartsTurn is not designed to be called during something else than adventure screen. End turn of blue player seems to be undesired in this case. Further investigation is needed.
(0006989)
SXX (administrator)
2017-03-18 22:29

0002163 likely caused by same problem.
(0006990)
SXX (administrator)
2017-03-19 02:25

This is now fixed:
https://github.com/vcmi/vcmi/commit/09d593e59b27f6fd46afad96c9fd369fe1565616 [^]

Thanks to @dydzio to pointing out and testing.

- Issue History
Date Modified Username Field Change
2014-09-23 17:19 Povelitel New Issue
2014-09-23 17:19 Povelitel Status new => assigned
2014-09-23 17:19 Povelitel Assigned To => Tow
2014-09-23 17:19 Povelitel File Added: Arrogance5.h3m
2014-09-23 17:19 Povelitel File Added: VCMI_Client_log.txt
2014-09-23 17:20 Povelitel File Added: VCMI_Server_log.txt
2014-09-23 17:42 Ivan Category AI - Battles => AI - Adventure Map
2014-09-23 17:42 Ivan Summary After the battle, the game is blocked => Game hangs after AI captures town from player in battle
2014-09-23 17:42 Ivan Description Updated View Revisions
2014-11-20 12:22 Povelitel Note Added: 0005133
2014-11-20 12:22 Povelitel Note Edited: 0005133 View Revisions
2014-12-20 10:46 Warmonger Relationship added has duplicate 0001948
2014-12-27 17:43 Warmonger Relationship added related to 0001724
2015-01-24 21:29 Warmonger Relationship added has duplicate 0002045
2015-03-05 13:24 Warmonger Relationship added related to 0002122
2015-03-25 09:33 Warmonger Relationship added related to 0002141
2016-10-02 12:24 Povelitel Assigned To Tow => SXX
2016-11-03 08:47 Povelitel Note Added: 0006888
2016-11-03 08:49 Povelitel Steps to Reproduce Updated View Revisions
2016-11-10 09:42 Povelitel Relationship added related to 0002597
2017-01-28 21:21 val-gaav Note Added: 0006962
2017-02-01 15:08 Dydzio Note Added: 0006965
2017-03-18 18:37 Dydzio Note Added: 0006988
2017-03-18 22:29 SXX Relationship added has duplicate 0002163
2017-03-18 22:29 SXX Note Added: 0006989
2017-03-19 02:25 SXX Note Added: 0006990
2017-03-19 02:25 SXX Status assigned => resolved
2017-03-19 02:25 SXX Fixed in Version => 0.next
2017-03-19 02:25 SXX Resolution open => fixed

Site | Forums | Wiki | GitHub


Copyright © 2000 - 2017 MantisBT Team
Hosting provided by DigitalOcean